package simulation;

import configuration.SimulationConfigurationSingleton;
import metadata.WarehouseMetadata;

import java.util.ArrayList;
import java.util.Collection;

public class Warehouse extends Building implements WarehouseSubject {
    private final Collection<Component> planes = new ArrayList<>();
    private final Collection<WarehouseObserver> observers = new ArrayList<>();
    private final int capacity = ((WarehouseMetadata) SimulationConfigurationSingleton.getInstance()
            .getConfiguration().getMetadata().get(getType()))
            .getInput().getCapacity();

    public Warehouse(int id, String type, int x, int y) {
        super(id, type, x, y);
    }

    @Override
    public void processInput(Component input) {
        planes.add(input);
    }

    private void sellComponent() {
    }

    public void attach(WarehouseObserver observer) {
        observers.add(observer);
    }

    public void dettach(WarehouseObserver observer) {
        observers.remove(observer);
    }

    public void notifyObservers() {
        boolean isFull = planes.size() >= capacity;
        observers.forEach(o -> o.update(isFull));
    }
}
